<?php 

/**
 Vana Allo Setup Controller
 @Copyright 2016 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.max2play.com

 */

include_once(APPLICATION_PATH.'/controller/Start.php');

class Allo_Setup extends Start {

	public $scriptPath = '';
	
	public $usbSoundCards = array('' => array('dtoverlay' => '', 'name' => 'none', 'squeezelite' => '-o plugequal -a 80:::', 'shairport' => '-d plugequal', 'mpd_mixer_control' => 'PCM'),
			'Piano DAC' => array('dtoverlay' => 'allo-piano-dac-pcm512x-audio', 'name' => 'Allo Piano HiFi DAC 2.0', 'squeezelite' => '-o default:CARD=PianoDAC -o hw:CARD=PianoDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=PianoDAC -t hardware -m hw:CARD=PianoDAC -c Digital', 'mpd_device' => 'default:CARD=PianoDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'PianoDAC'),
			'Piano DAC Subwoofer' => array('dtoverlay' => 'allo-piano-dac-plus-pcm512x-audio', 'name' => 'Allo Piano HiFi DAC 2.1', 'squeezelite' => '-o default:CARD=PianoDACPlus -o hw:CARD=PianoDACPlus -V Digital -a 80:4::', 'shairport' => '-d default:CARD=PianoDACPlus -t hardware -m hw:CARD=PianoDACPlus -c Digital', 'mpd_device' => 'default:CARD=PianoDACPlus', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'PianoDACPlus'),
			'Allo Boss' => array('dtoverlay' => 'allo-boss-dac-pcm512x-audio', 'name' => 'Allo Boss HiFi DAC', 'squeezelite' => '-o default:CARD=BossDAC -o hw:CARD=BossDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=BossDAC -t hardware -m hw:CARD=BossDAC -c Digital', 'mpd_device' => 'default:CARD=BossDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'BossDAC'),
            'Allo Boss 2' => array('dtoverlay' => 'allo-boss2-dac-audio', 'name' => 'Allo Boss 2 HiFi DAC', 'squeezelite' => '-o default:CARD=Boss2 -o hw:CARD=Boss2 -V Master -a 80:4::', 'shairport' => '-d default:CARD=Boss2 -t hardware -m hw:CARD=Boss2 -c Master', 'mpd_device' => 'default:CARD=Boss2', 'mpd_mixer_control' => 'Master', 'amixercard' => 'Boss2'),
	        'Allo MiniBoss' => array('dtoverlay' => 'allo-boss-dac-pcm512x-audio', 'name' => 'Allo MiniBoss HiFi DAC', 'squeezelite' => '-o default:CARD=BossDAC -o hw:CARD=BossDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=BossDAC -t hardware -m hw:CARD=BossDAC -c Digital', 'mpd_device' => 'default:CARD=BossDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'BossDAC'),
			'Allo Digione' => array('dtoverlay' => 'allo-digione', 'name' => 'Allo Digione', 'squeezelite' => '-o default:CARD=sndallodigione', 'shairport' => '-d default:CARD=sndallodigione', 'mpd_device' => 'default:CARD=sndallodigione')
			);
	public $usbSoundCardsSparky = array('' => array('dtoverlay' => '', 'name' => 'none', 'squeezelite' => '-o plugequal -a 80:::', 'shairport' => '-d plugequal', 'mpd_mixer_control' => 'PCM'),
			'Piano DAC' => array('dtoverlay' => '', 'name' => 'Allo Piano HiFi DAC 2.0', 'squeezelite' => '-o default:CARD=PianoDAC -o hw:CARD=PianoDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=PianoDAC -t hardware -m hw:CARD=PianoDAC -c Digital', 'mpd_device' => 'default:CARD=PianoDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'PianoDAC', 'modules' => 'snd-soc-allo-piano-dac'),
			'Piano DAC Subwoofer' => array('dtoverlay' => '', 'name' => 'Allo Piano HiFi DAC 2.1 (Custom Kernel)', 'squeezelite' => '-o default:CARD=PianoDACPlus -o hw:CARD=PianoDACPlus -V Digital -a 80:4::', 'shairport' => '-d default:CARD=PianoDACPlus -t hardware -m hw:CARD=PianoDACPlus -c Digital', 'mpd_device' => 'default:CARD=PianoDACPlus', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'PianoDACPlus', 'modules' => 'snd-soc-allo-piano-dac-plus'),
			'Allo Cheapo DAC PCM' => array('dtoverlay' => '', 'name' => 'Allo Cheapo DAC: Output PCM', 'squeezelite' => '-o default:CARD=atm7059link -o hw:CARD=atm7059link -a 80:4:: -V \'DAC PA\'', 'shairport' => '-d default:CARD=atm7059link', 'mpd_device' => 'default:CARD=atm7059link', 'mpd_mixer_control' => '"DAC PA"', 'amixercard' => 'atm7059link'),
			'Allo Cheapo DAC SPDIF' => array('dtoverlay' => '', 'name' => 'Allo Cheapo DAC: Output SPDIF', 'squeezelite' => '-o default:CARD=atm7059link -o hw:CARD=atm7059link,DEV=2 -a 80:4::', 'shairport' => '-d default:CARD=atm7059link,DEV=2', 'mpd_device' => 'default:CARD=atm7059link,DEV=2', 'mpd_mixer_control' => '"DAC PA"', 'amixercard' => 'atm7059link')
			
	);
	public $alsasettings = array(
			'Piano DAC' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB)', 'default' => 51),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost', 'valMap' => '[0, 100]', 'default' => 0),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100)),
			'Allo Boss' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB)', 'default' => 51),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost', 'valMap' => '[0, 100]', 'default' => 0),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100)),
            'Allo Boss 2' => array(
                'Master' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB)', 'default' => 51),
                'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost', 'valMap' => '[0, 100]', 'default' => 0),
                'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100)),
			'Piano DAC Subwoofer' => array(									        
			        'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Speaker Volume (100 = 0 dB)', 'default' => 51),
					'Subwoofer Digital' => array('min' => 0, 'max' => 100, 'description' => 'Subwoofer Volume (100 = 0 dB)', 'default' => 51),
					'Subwoofer' => array('min' => 0, 'max' => 100, 'description' => 'Subwoofer Volume (100 = 0 dB)', 'default' => 51),
			        'Master' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB) - synchronized volume changes for Speaker and Subwoofer', 'default' => 51),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost', 'valMap' => '[0, 100]', 'default' => 0),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100),
					'Dual Mode' => array('min' => 0, 'max' => 100, 'description' => 'Dual Mode (Double Stereo or Double Mono, <b>needs Subwoofer set to "None"!</b>), Default None', 'valMap' => '["None", "Dual-Mono", "Dual-Stereo"]', 'default' => 'None'),
					'Subwoofer mode' => array('min' => 0, 'max' => 100, 'description' => 'Subwoofer Mode (2.0, 2.1, 2.2), Default 2.1', 'valMap' => '["None", "2.0", "2.1", "2.2"]', 'default' => '2.1'),
					'DSP Low pass Program' => array('min' => 60, 'max' => 200, 'description' => 'Subwoofer Cut-Off Frequency (Lowpass filter)', 'valMap' => '[60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200]', 'default' => 90),
				    'Lowpass' => array('min' => 60, 'max' => 200, 'description' => 'Subwoofer Cut-Off Frequency (Lowpass filter)', 'valMap' => '[60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200]', 'default' => 90)),
			'Allo Cheapo DAC PCM' => array(
					'DAC PA' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB)', 'default' => 51)),
					//'audio output mode switch' => array('min' => 0, 'max' => 100, 'description' => 'Audio Output Mode Switch for I2S OR SPDIF', 'valMap' => '["i2s", "spdif"]', 'default' => 'i2s')),					
			'Allo Cheapo DAC SPDIF' => array(
					'DAC PA' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB)', 'default' => 51))					
					//'audio output mode switch' => array('min' => 0, 'max' => 100, 'description' => 'Audio Output Mode Switch for I2S OR SPDIF', 'valMap' => '["i2s", "spdif"]', 'default' => 'spdif')				
			);
	
	public function __construct(){				
		parent::__construct();
		$this->pluginname = _('ALLO');
		$this->registerLocale(dirname(__FILE__).'/../locale', 'allo');
		$this->scriptPath = dirname(__FILE__).'/../scripts/';
		
		if($_REQUEST['ajax'] == 1){
			if ($_REQUEST['action'] == 'installKernelPi')
				$this->_installKernelPi($ajax = 1);
			if ($_REQUEST['action'] == 'display_install')
			    $this->_installDisplay($ajax = 1);
			ob_end_clean();
			echo implode('<br />', $this->view->message);
			ob_flush();
			die();
		}
		
		// Check for Board Version and choose configuration for DAC DTOVERLAY
		if($this->getHardwareInfo() == 'Allo Sparky'){
			$this->usbSoundCards = $this->usbSoundCardsSparky;
			$this->alsamixerParameter = '';
		}elseif($this->getHardwareInfo() == 'Raspberry PI'){
			// Kernel Check for Drivers PianoDAC
			if(!file_exists('/boot/overlays/allo-piano-dac-pcm512x-audio.dtbo') && $_REQUEST['action'] != 'installKernelPi'){				
				$this->view->message[] = _t('<b>Important</b>: The Piano DAC uses special drivers that need to be installed first! <a href="?action=installKernelPi&card=DACPLUS">Click here to install Kernel Drivers now</a>');
			}
			//Copy DSP-Files for 2.1 DAC!
			if(!file_exists('/lib/firmware/allo/piano')){
				$this->writeDynamicScript(array('tar -xvzf '.$this->scriptPath.'alloPianoDACfw.tgz -C /'));
				//TODO Need to install complete modified Kernel until Update...
				$this->view->message[] = _t('Enabled Allo Firmware for PianoDAC Support');
			}						
			
			// alsamixerParameter is used to get % values instead of -db (linear scale instead of exponential volume change)
			$this->alsamixerParameter = '-M';
		}
		
		$this->checkPicturesAndHeader('allo', dirname(__FILE__));			
		
		$this->_getDTOverlayConfig();
		
		if(isset($_REQUEST['action'])){
			if($_REQUEST['action'] == 'save_dtoverlay'){
				$this->_saveDtoverlay();
				$this->_getDTOverlayConfig();
			}
			if($_REQUEST['action'] == 'reset_defaults'){
				$this->_saveAlsa($default = true);
			}
			if($_REQUEST['action'] == 'save_dtoverlay' && $this->view->dtoverlay == $_REQUEST['dtoverlay']){
				$this->_saveAlsa();
			}
			if($_REQUEST['action'] == 'installKernelPi'){
				if(isset($_REQUEST['card']))
					$card=$_REQUEST['card'];
				else 
					$card='DACPLUS';
				$this->_installKernelPi($ajax = 0, $card);
			}
		}
		$this->getAlsaAudio();
        $this->_displayHandler();
		$this->easyinstaller = true;
		
	}
	
	private function _getDTOverlayConfig(){
		$this->view->dtoverlay = $this->getConfigFileParameter('/opt/max2play/options.conf', 'audiocard');
		if($this->view->dtoverlay == ''){
			$this->view->message[] = _t('You have not yet choosen your installed Allo card! You must do this before you can use your audioplayers with your Allo card! Please choose your card and finish the setup below.');
		}
		if($this->view->dtoverlay == 'Allo Boss' && !file_exists('/boot/overlays/allo-piano-dac-plus-pcm512x-audio.dtbo')){
			$this->view->message[] = _t('<b>Important</b>: The PianoDAC with Subwoofer and the Allo Boss need a custom Kernel to run! <a href="?action=installKernelPi&card=DACPLUS">Click here to install custom Kernel now!</a>');
		}
        if($this->view->dtoverlay == 'Allo Boss 2' && !file_exists('/boot/overlays/allo-boss2-dac-audio.dtbo')){
            $this->view->message[] = _t('<b>Important</b>: The Allo Boss 2 need a newer Kernel (Version 5.4.77) to run! <a href="/plugins/raspberrysettings/controller/Setup.php?action=kernelupdate">Click here to install the newest Kernel now!</a>');
        }
		if($this->view->dtoverlay == 'Piano DAC Subwoofer'){
			if(method_exists($this, 'Rpi_functions')){
				$Rpi_functions = $this->Rpi_functions();
				if (method_exists($Rpi_functions, 'compareKernelVersion')){
					$updateKernel = $Rpi_functions->compareKernelVersion('4.9.36'); // needs at least 4.9.36					
				}
			}
			if(!isset($updateKernel)){
				// OLD METHOD -> Remove later
				$kernelversion = explode('.',trim($this->shell_exec('uname --all | grep -oe " [0-9]\+\.[0-9\.]\+"')));			
				$minkernel = array(0 => 4, 1 => 9, 2 => 36); 
				$updateKernel=false;				
				foreach($minkernel as $key => $min){
					if(isset($kernelversion[$key]) && $kernelversion[$key] > $min){
						break;
					}elseif(isset($kernelversion[$key]) && $kernelversion[$key] == $min){
					    // Check further...
					}else{
						$updateKernel=true;
					}
				}
			}
			if($updateKernel)
				$this->view->message[] = _t('<b>Important</b>: The PianoDAC with Subwoofer needs Kernel Version 4.9.36 to have Dual Mode enabled! <a href="?action=installKernelPi&card=DACSUBWOOFER">Click here to install latest Kernel now!</a>');
		}
		if(($this->view->dtoverlay == 'Allo Digione' || $this->view->dtoverlay == 'Allo Digione') && !file_exists('/boot/overlays/allo-digione.dtbo')){
			$this->view->message[] = _t('<b>Important</b>: The Allo Digione needs at least Kernel 4.9.31 to run! Please update to the latest Kernel on the Raspberry Pi Settings Page (Button at bottom of the Page)!');
		}
		
		return true;
	}
	
	private function _saveDtoverlay(){
		if(isset($_REQUEST['dtoverlay']) && in_array($_REQUEST['dtoverlay'], array_keys($this->usbSoundCards)) && $this->view->dtoverlay != $_REQUEST['dtoverlay']){										
		    $this->saveDTOverlayConfig($this->usbSoundCards[$_REQUEST['dtoverlay']]['dtoverlay'], 'soundcard');		    
			$this->saveConfigFileParameter('/opt/max2play/options.conf', 'audiocard', $_REQUEST['dtoverlay']);
			//Set Modules for Sparky
			if(isset($this->usbSoundCards[$_REQUEST['dtoverlay']]['modules'])){
				$this->writeDynamicScript(array('sed -i "s/snd-soc-allo-piano-dac-plus$//;s/snd-soc-allo-piano-dac$//" /etc/modules'));
				$this->writeDynamicScript(array('echo "'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['modules'].'" >> /etc/modules'));
			}
			
			// Setup Mode for Sparky
			if($this->getHardwareInfo() != 'Raspberry PI'){
				$user = $this->getSystemUser();
				if($_REQUEST['dtoverlay'] == 'Allo Cheapo DAC SPDIF'){				
					$script = array('su - '.$user.' -c \'amixer -c 0 -q set "audio output mode switch" "spdif"\'');
					$output = $this->writeDynamicScript($script);
				}else{
					$script = array('su - '.$user.' -c \'amixer -c 0 -q set "audio output mode switch" "i2s"\'');
					$output = $this->writeDynamicScript($script);
				}
			}					
				
			//Set Squeezelite Parameter
			$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SQUEEZELITE_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['squeezelite']);
			$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SHAIRPORT_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['shairport']);					
			
			//MPD Parameter Vana
			if(file_exists('/etc/mpd.conf')){
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'mixer_control', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_mixer_control'].'\"', $separator = '\\t');
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'format', $value = '\"192000:24:2\"', $separator = '\\t');
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'device', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_device'].'\"', $separator = '\\t');
				$this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'mixer_device', $value = '\"'.$this->getSoundcardPosition('PianoDAC').'\"', $separator = '\\t');
			}						
			
			$this->view->message[] = _("Boot config parameters changed");
			$this->view->message[] = str_replace('$SERVERIP', $this->getServerUrl($ipv4=true), _('Please restart your device! To restart now <a href="http://$SERVERIP/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl='.urlencode('http://').'$SERVERIP">just click here</a>.'));
			
			if($_REQUEST['dtoverlay'] == 'Piano DAC Subwoofer' && !file_exists('/boot/overlays/allo-piano-dac-plus-pcm512x-audio.dtbo')){
				$this->view->message[] = _t('<b>Important</b>: The PianoDAC with Subwoofer needs a custom Kernel to run! <a href="?action=installKernelPi&card=DACPLUS">Click here to install custom Kernel now!</a>');
			}
		}		
		return true;
	}
	
	/**
	 * Important! dtoverlay Parameter might be set multiple times in config.txt -> separate handling needed
	 * @param string $value
	 * @param string $dto_type Possible values: soundcard, single_option
	 * @return boolean
	 */
	private function saveDTOverlayConfig($value = '', $dto_type = 'notset', $dto_param = ''){
	    $dto_entries['soundcard'] = array();
	    
	    // NEW Method!
	    if(method_exists($this, 'Rpi_functions')){
	        $Rpi_functions = $this->Rpi_functions();
	        if($dto_param != '') // For Lirc
	            $value = $value.','.$dto_param;
            $rpi_Object = get_object_vars($Rpi_functions);
            if(isset($rpi_Object['usbSoundCards'])){
                foreach($rpi_Object['usbSoundCards'] as $card){
                    if (isset($card['dtoverlay']) && $card['dtoverlay'] != '')
                        $dto_entries['soundcard'][] = $card['dtoverlay'];
                }
            }
            // Bugfix for Private Method in RPI-Functions...
            if(in_array('saveDTOverlayConfig', get_class_methods($Rpi_functions))){
                $Rpi_functions->saveDTOverlayConfig($value, $dto_type);
                return true;
            }
	    }
	}
	
	/**
	 * get soundcard position e.g. hw:0 or hw:1
	 * @param string $soundcard
	 * @return string for MPD mixer_device
	 */
	private function getSoundcardPosition($soundcard = ''){
		$aplayOutput = $this->writeDynamicScript(array('LANG=C && aplay -l | grep "card"'));
		//card 0: ALSA [bcm2835 ALSA], device 1: bcm2835 ALSA [bcm2835 IEC958/HDMI]
		//card 1: IQaudIODAC [IQaudIODAC], device 0: IQaudIO DAC HiFi pcm512x-hifi-0 []
		if(!preg_match_all('=^card ([0-9]): ([^ ]*)=im', $aplayOutput, $aplayMatches))
			return 'default';
		$count = count($aplayMatches[1]);
		$aplayCards = array();
		for($i = 0; $i < $count; $i++){
			$aplayCards[$aplayMatches[2][$i]] = $aplayMatches[1][$i];
		}
		if(isset($aplayCards[$soundcard]))
			return 'hw:'.$aplayCards[$soundcard];
		else
			return 'default';
	}

	/**
	 * get Alsa Settings For AudioCard
	 */
	public function getAlsaAudio(){
		$this->view->alsavalues = false;
		if($this->view->dtoverlay && isset($this->alsasettings[$this->view->dtoverlay])){
			$user = $this->getSystemUser();			
			if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
				$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
			}else{
				$amixercard = '';
			}
			foreach($this->alsasettings[$this->view->dtoverlay] as $key => $value){				
				$script = array('su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' sget "'.$key.'"\'');
				$output = $this->writeDynamicScript($script);
				preg_match('=\[([^\]]*)\]|Item0: \'([0-9a-zA-Z\-\\.]+)\'=', $output, $match);
				if(isset($match[2])){
					$this->view->alsavalues[$key] = $value;
					$this->view->alsavalues[$key]['type'] = '';					
					$this->view->alsavalues[$key]['value'] = $match[2];					
				}elseif(isset($match[1])){
					$this->view->alsavalues[$key] = $value;
					if(strpos($match[1], '%') !== FALSE)
						$this->view->alsavalues[$key]['type'] = '%';
					else
						$this->view->alsavalues[$key]['type'] = '';
					$this->view->alsavalues[$key]['value'] = intval($match[1]);
				}
			}
		}		
		return true;
	}
	
	/**
	 * Change Kernel for drivers on Raspberry Pi
	 * @param number $ajax
	 * @return boolean
	 */
	private function _installKernelPi($ajax = 0, $card = 'DACPLUS'){
		$outfile = '/opt/max2play/cache/upgradeSystem.txt';
		if($ajax == 0){
			ignore_user_abort(true);
			set_time_limit(3000);
			$this->view->message[] = _('Kernel Update started');
			if($this->getProgressWithAjax($outfile, 1, 0)){
				//run it as a deamon to enable apache updates
				$shellanswer = $this->writeDynamicScript(array($this->scriptPath.'install_kernel.sh '.$this->info->chipset." ".$card." >> ".$outfile." 2>&1;echo 'Finished - Reboot needed! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/allo/controller/Setup.php\">Click here to Reboot Now</a></b>' >> ".$outfile), false, true);
			}
		}else{
			$status = $this->getProgressWithAjax($outfile, 0, 0, 30);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'Finished') !== FALSE){
				//Finished Progress - did not delete progressfile				
				shell_exec('rm '.$outfile);
				
				// Force Redo of DTOverlay Config - might be overwritten by config.txt
				$this->_getDTOverlayConfig();
				$_REQUEST['dtoverlay'] = $this->view->dtoverlay;
				$this->view->dtoverlay = '';
				$this->_saveDtoverlay();
			}
		}
		return true;
	}	
	
	public function _saveAlsa($default = false){
		$user = $this->getSystemUser();
		$this->getAlsaAudio();
		$script = array();
		if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
			$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
		}else{
			$amixercard = '';
		}
		if(is_array($this->view->alsavalues)){
		  foreach($this->view->alsavalues as $key => $value){
		    if($_REQUEST[str_replace(' ','_', $key).'_changed'] == "1"){
    		    // Only change values that were manually edited (slider moved)
		        if($key == 'Subwoofer mode' && ($value['value'] != $_REQUEST[str_replace(' ','_', $key)] || true == $default && $value['default'] != $value['value'])){
    				$this->view->message[] = _t("A Reboot is needed after changing the Subwoofer Mode! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/allo/controller/Setup.php\">Click here to Reboot Now</a></b>");
    			}
    			if(!$default)
    				$script[] = 'su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' -q set "'.$key.'" "'.$_REQUEST[str_replace(' ','_', $key)].$value['type'].'"\'';
    			elseif(isset($value['default']))
    				$script[] = 'su - '.$user.' -c \'amixer '.$this->alsamixerParameter.' '.$amixercard.' -q set "'.$key.'" "'.$value['default'].$value['type'].'"\'';
    			$script[] = 'su - '.$user.' -c \'alsactl store\'';
		    }
		  }
		}
		if(isset($script[0])){
			$output = nl2br($this->writeDynamicScript($script));
			if($output != '')
				$this->view->message[] = $output;
			$this->view->message[] = _("Updated Alsa Settings");
		}
		return true;
	}

    public function _displayHandler(){
        if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'display_install'){
            $this->_installDisplay();
        }
        if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'display_save'){
            if(!isset($_REQUEST['autostartdisplay'])){
                // TODO: remove from rc.local OR disable Service boss2oled.service --> check...
            }
            $this->view->message[] = str_replace('$SERVERIP', $this->getServerUrl($ipv4=true), _('Please restart your device! To restart now <a href="http://$SERVERIP/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl='.urlencode('http://').'$SERVERIP">just click here</a>.'));
        }
        // Check for existing Script
        if(!file_exists('/opt/boss2_oled/')){
            $this->display_installed = false;
            return false;
        }
        $this->display_installed = true;
        $this->displayPID = $this->status("python");
        $this->autostartdisplay = $this->checkAutostart('DISPLAY_AUTOSTART', true);
        return true;
    }

    /**
     * Install Display Support for Winstar OLED on Raspberry Pi
     * @param $ajax IsAjax
     * @return boolean
     */
    private function _installDisplay($ajax = 0){
        $outfile = '/opt/max2play/cache/installDisplay.txt';
        if($ajax == 0){
            ignore_user_abort(true);
            set_time_limit(3000);
            $this->view->message[] = _t('Display Setup Started');
            $this->view->message[] = _t('Device will be rebooted automatically after Installation');
            if($this->getProgressWithAjax($outfile, 1, 0)){
                //run it as a deamon to enable apache updates
                $shellanswer = $this->writeDynamicScript(array($this->scriptPath ."install_display.sh >> ".$outfile." 2>&1 &", false, true));
            }
        }else{
            $status = $this->getProgressWithAjax($outfile, 0, 0, 30);
            $this->view->message[] = nl2br($status);
            if(strpos($status, 'Finished Display Installer') !== FALSE){
                //Finished Progress - did not delete progressfile
                shell_exec('rm '.$outfile);
            }
        }
        return true;
    }
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - Allo Edition');
		$helpSidebar['content'] = _t('<ul><li>You want to know more about this special Max2Play-Version? You may watch <a target="_blank" href="https://youtu.be/AOlHpEcVEYE">a video tutorial about the settings on this page</a>.</li></ul>');
		$helpSidebar['toppicture'] = '/images/start-toppicture.jpg';
		return true;
	}	
		
}

$start = new Allo_Setup();

include_once(dirname(__FILE__).'/../view/setup.php');

